# generated by datamodel-codegen:
#   filename:  create_data_room.json

from __future__ import annotations

from enum import Enum
from typing import Mapping, Optional, Sequence

from pydantic import BaseModel, ConfigDict, Field, RootModel


class Version(Enum):
    v0 = 'v0'


class FormatType(Enum):
    STRING = 'STRING'
    INTEGER = 'INTEGER'
    FLOAT = 'FLOAT'
    EMAIL = 'EMAIL'
    DATE_ISO8601 = 'DATE_ISO8601'
    PHONE_NUMBER_E164 = 'PHONE_NUMBER_E164'
    HASH_SHA256_HEX = 'HASH_SHA256_HEX'


class HashingAlgorithm(Enum):
    SHA256_HEX = 'SHA256_HEX'


class Permission(Enum):
    VIEW_OVERLAP = 'VIEW_OVERLAP'
    VIEW_INSIGHTS = 'VIEW_INSIGHTS'
    PROVIDE_SEED_AUDIENCE = 'PROVIDE_SEED_AUDIENCE'
    PROVIDE_BASE_AUDIENCE = 'PROVIDE_BASE_AUDIENCE'
    CREATE_CUSTOM_AUDIENCE = 'CREATE_CUSTOM_AUDIENCE'
    EXPORT_AUDIENCE = 'EXPORT_AUDIENCE'
    MODEL_QUALITY = 'MODEL_QUALITY'


class CreateMediaDcr1(BaseModel):
    audiencesPolicyId: Optional[str] = None
    demographicsPolicyId: Optional[str] = None
    embeddingsPolicyId: Optional[str] = None
    enableDebugMode: bool
    enableInsights: bool
    enableLookalikeAudiences: bool
    enableRemarketing: bool
    enableRuleBasedAudiences: bool
    hashMatchingIdWith: Optional[HashingAlgorithm] = None
    hideAbsoluteValuesFromInsights: bool
    matchingIdFormat: FormatType
    matchingIdsPolicyId: Optional[str] = None
    name: str
    participants: Mapping[str, Sequence[Permission]]
    segmentsPolicyId: Optional[str] = None
    version: Version


class CreateMediaDcr(RootModel[CreateMediaDcr1]):
    root: CreateMediaDcr1


class CreateDataRoom1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    media: CreateMediaDcr


class CreateDataRoom(RootModel[CreateDataRoom1]):
    root: CreateDataRoom1 = Field(..., title='CreateDataRoom')
